Linux Audio

Check our new training course

Loading...
v3.1
 
 1#
 2# Kbuild for top-level directory of the kernel
 3# This file takes care of the following:
 4# 1) Generate bounds.h
 5# 2) Generate asm-offsets.h (may need bounds.h)
 6# 3) Check for missing system calls
 7
 8#####
 9# 1) Generate bounds.h
 
 
10
11bounds-file := include/generated/bounds.h
12
13always  := $(bounds-file)
14targets := $(bounds-file) kernel/bounds.s
15
16quiet_cmd_bounds = GEN     $@
17define cmd_bounds
18	(set -e; \
19	 echo "#ifndef __LINUX_BOUNDS_H__"; \
20	 echo "#define __LINUX_BOUNDS_H__"; \
21	 echo "/*"; \
22	 echo " * DO NOT MODIFY."; \
23	 echo " *"; \
24	 echo " * This file was generated by Kbuild"; \
25	 echo " *"; \
26	 echo " */"; \
27	 echo ""; \
28	 sed -ne $(sed-y) $<; \
29	 echo ""; \
30	 echo "#endif" ) > $@
31endef
32
33# We use internal kbuild rules to avoid the "is up to date" message from make
34kernel/bounds.s: kernel/bounds.c FORCE
35	$(Q)mkdir -p $(dir $@)
36	$(call if_changed_dep,cc_s_c)
37
38$(obj)/$(bounds-file): kernel/bounds.s Kbuild
39	$(Q)mkdir -p $(dir $@)
40	$(call cmd,bounds)
41
42#####
43# 2) Generate asm-offsets.h
44#
 
 
 
 
 
 
 
45
46offsets-file := include/generated/asm-offsets.h
47
48always  += $(offsets-file)
49targets += $(offsets-file)
50targets += arch/$(SRCARCH)/kernel/asm-offsets.s
51
 
52
53# Default sed regexp - multiline due to syntax constraints
54define sed-y
55	"/^->/{s:->#\(.*\):/* \1 */:; \
56	s:^->\([^ ]*\) [\$$#]*\([-0-9]*\) \(.*\):#define \1 \2 /* \3 */:; \
57	s:^->\([^ ]*\) [\$$#]*\([^ ]*\) \(.*\):#define \1 \2 /* \3 */:; \
58	s:->::; p;}"
59endef
60
61quiet_cmd_offsets = GEN     $@
62define cmd_offsets
63	(set -e; \
64	 echo "#ifndef __ASM_OFFSETS_H__"; \
65	 echo "#define __ASM_OFFSETS_H__"; \
66	 echo "/*"; \
67	 echo " * DO NOT MODIFY."; \
68	 echo " *"; \
69	 echo " * This file was generated by Kbuild"; \
70	 echo " *"; \
71	 echo " */"; \
72	 echo ""; \
73	 sed -ne $(sed-y) $<; \
74	 echo ""; \
75	 echo "#endif" ) > $@
76endef
77
78# We use internal kbuild rules to avoid the "is up to date" message from make
79arch/$(SRCARCH)/kernel/asm-offsets.s: arch/$(SRCARCH)/kernel/asm-offsets.c \
80                                      $(obj)/$(bounds-file) FORCE
81	$(Q)mkdir -p $(dir $@)
82	$(call if_changed_dep,cc_s_c)
83
84$(obj)/$(offsets-file): arch/$(SRCARCH)/kernel/asm-offsets.s Kbuild
85	$(call cmd,offsets)
86
87#####
88# 3) Check for missing system calls
89#
90
91quiet_cmd_syscalls = CALL    $<
92      cmd_syscalls = $(CONFIG_SHELL) $< $(CC) $(c_flags)
93
94PHONY += missing-syscalls
95missing-syscalls: scripts/checksyscalls.sh FORCE
96	$(call cmd,syscalls)
97
98# Keep these two files during make clean
99no-clean-files := $(bounds-file) $(offsets-file)
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
v6.2
 1# SPDX-License-Identifier: GPL-2.0
 2#
 3# Kbuild for top-level directory of the kernel
 
 
 
 
 4
 5# Prepare global headers and check sanity before descending into sub-directories
 6# ---------------------------------------------------------------------------
 7
 8# Generate bounds.h
 9
10bounds-file := include/generated/bounds.h
11
12targets := kernel/bounds.s
 
13
14$(bounds-file): kernel/bounds.s FORCE
15	$(call filechk,offsets,__LINUX_BOUNDS_H__)
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
16
17# Generate timeconst.h
18
19timeconst-file := include/generated/timeconst.h
20
21filechk_gentimeconst = echo $(CONFIG_HZ) | bc -q $<
22
23$(timeconst-file): kernel/time/timeconst.bc FORCE
24	$(call filechk,gentimeconst)
25
26# Generate asm-offsets.h
27
28offsets-file := include/generated/asm-offsets.h
29
 
 
30targets += arch/$(SRCARCH)/kernel/asm-offsets.s
31
32arch/$(SRCARCH)/kernel/asm-offsets.s: $(timeconst-file) $(bounds-file)
33
34$(offsets-file): arch/$(SRCARCH)/kernel/asm-offsets.s FORCE
35	$(call filechk,offsets,__ASM_OFFSETS_H__)
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
36
37# Check for missing system calls
 
 
38
39quiet_cmd_syscalls = CALL    $<
40      cmd_syscalls = $(CONFIG_SHELL) $< $(CC) $(c_flags) $(missing_syscalls_flags)
41
42PHONY += missing-syscalls
43missing-syscalls: scripts/checksyscalls.sh $(offsets-file)
44	$(call cmd,syscalls)
45
46# Check the manual modification of atomic headers
47
48quiet_cmd_check_sha1 = CHKSHA1 $<
49      cmd_check_sha1 = \
50	if ! command -v sha1sum >/dev/null; then \
51		echo "warning: cannot check the header due to sha1sum missing"; \
52		exit 0; \
53	fi; \
54	if [ "$$(sed -n '$$s:// ::p' $<)" != \
55	     "$$(sed '$$d' $< | sha1sum | sed 's/ .*//')" ]; then \
56		echo "error: $< has been modified." >&2; \
57		exit 1; \
58	fi; \
59	touch $@
60
61atomic-checks += $(addprefix $(obj)/.checked-, \
62	  atomic-arch-fallback.h \
63	  atomic-instrumented.h \
64	  atomic-long.h)
65
66targets += $(atomic-checks)
67$(atomic-checks): $(obj)/.checked-%: include/linux/atomic/%  FORCE
68	$(call if_changed,check_sha1)
69
70# A phony target that depends on all the preparation targets
71
72PHONY += prepare
73prepare: $(offsets-file) missing-syscalls $(atomic-checks)
74	@:
75
76# Ordinary directory descending
77# ---------------------------------------------------------------------------
78
79obj-y			+= init/
80obj-y			+= usr/
81obj-y			+= arch/$(SRCARCH)/
82obj-y			+= $(ARCH_CORE)
83obj-y			+= kernel/
84obj-y			+= certs/
85obj-y			+= mm/
86obj-y			+= fs/
87obj-y			+= ipc/
88obj-y			+= security/
89obj-y			+= crypto/
90obj-$(CONFIG_BLOCK)	+= block/
91obj-$(CONFIG_IO_URING)	+= io_uring/
92obj-$(CONFIG_RUST)	+= rust/
93obj-y			+= $(ARCH_LIB)
94obj-y			+= drivers/
95obj-y			+= sound/
96obj-$(CONFIG_SAMPLES)	+= samples/
97obj-$(CONFIG_NET)	+= net/
98obj-y			+= virt/
99obj-y			+= $(ARCH_DRIVERS)